<template>
  <div
    class="h-screen flex w-full bg-img vx-row no-gutter items-center justify-center"
  >
    <div class="vx-col sm:w-1/2 md:w-1/2 lg:w-3/4 xl:w-3/5 sm:m-0 m-4">
      <vx-card>
        <div slot="no-body" class="full-page-bg-color">
          <div class="vx-row no-gutter">
            <div
              class="vx-col hidden sm:hidden md:hidden lg:block lg:w-1/2 mx-auto self-center"
            >
              <img
                src="@/assets/images/pages/register.jpg"
                alt="register"
                class="mx-auto"
              />
            </div>
            <div
              class="vx-col sm:w-full md:w-full lg:w-1/2 mx-auto self-center  d-theme-dark-bg"
            >
              <div class="px-8 pt-8 register-tabs-container">
                <div class="vx-card__title mb-4">
                  <h4 class="mb-4">Create Account</h4>
                  <p>Fill the below form to create a new account.</p>
                </div>
                <template>
                  <div class="clearfix">
                    <vs-input
                      v-validate="'required'"
                      data-vv-validate-on="blur"
                      label-placeholder="Name"
                      name="name"
                      placeholder="Name"
                      v-model="form.name"
                      class="w-full"
                    />
                    <span class="text-danger text-sm">{{
                      errors.first("name")
                    }}</span>

                    <vs-input
                      v-validate="'required|email'"
                      data-vv-validate-on="blur"
                      name="email"
                      type="email"
                      label-placeholder="Email"
                      placeholder="Email"
                      v-model="form.email"
                      class="w-full mt-6"
                    />
                    <span class="text-danger text-sm">{{
                      errors.first("email")
                    }}</span>

                    <vs-input
                      ref="password"
                      type="password"
                      data-vv-validate-on="blur"
                      v-validate="'required|min:6|max:10'"
                      name="password"
                      label-placeholder="Password"
                      placeholder="Password"
                      v-model="form.password"
                      class="w-full mt-6"
                    />
                    <span class="text-danger text-sm">{{
                      errors.first("password")
                    }}</span>

                    <vs-input
                      type="password"
                      v-validate="'min:6|max:10|confirmed:password'"
                      data-vv-validate-on="blur"
                      data-vv-as="password"
                      name="password_confirmation"
                      label-placeholder="Confirm Password"
                      placeholder="Confirm Password"
                      v-model="form.password_confirmation"
                      class="w-full mt-6"
                    />
                    <span class="text-danger text-sm">{{
                      errors.first("password_confirmation")
                    }}</span>

                    <vs-checkbox
                      v-model="form.isTermsConditionAccepted"
                      class="mt-6"
                      >I accept the terms & conditions.</vs-checkbox
                    >
                    <vs-button type="border" to="/pages/login" class="mt-6"
                      >Login</vs-button
                    >

                    <vs-button
                      class="float-right mt-6"
                      @click="register"
                      :disabled="!validateForm"
                      >Register</vs-button
                    >
                  </div>
                </template>
              </div>
            </div>
          </div>
        </div>
      </vx-card>
    </div>
  </div>
</template>

<script>
import { mapActions } from "vuex";
import axios from "../../axios";

export default {
  data() {
    return {
      form: {
        email: "",
        password: "",
        password_confirmation: "",
        checkbox_remember_me: false
      }
    };
  },

  computed: {
    validateForm() {
      return (
        !this.errors.any() &&
        this.form.name != "" &&
        this.form.email != "" &&
        this.form.password != "" &&
        this.form.password_confirmation != "" &&
        this.form.isTermsConditionAccepted === true
      );
    }
  },

  methods: {
    ...mapActions({
      signUp: "auth/register"
    }),

    registerUser() {
      this.$router
        .replace({
          name: "page-register"
        })
        .catch(() => {});
    },
    clearFields() {
      this.$nextTick(() => {
        this.form.email = "";
        this.form.password = "";
        this.form.password_confirmation = "";
        this.form.checkbox_remember_me = false;
      });
    },

    register() {
      axios.get("/sanctum/csrf-cookie").then(response => {
        console.log(response);
        this.signUp(this.form)
          .then(() => {
            this.$vs.notify({
              color: "success",
              title: "Success",
              text: "Successfully Logged In"
            });
            this.$router.replace({
              name: "home"
            });
          })
          .catch(() => {
            this.clearFields();
            this.$vs.notify({
              color: "danger",
              title: "Failed",
              text: "Invalid Credentials"
            });
          });
      });
    }
  }
};
</script>

<style lang="scss">
.register-tabs-container {
  min-height: 517px;

  .con-tab {
    padding-bottom: 23px;
  }
}
</style>
